<template>
  <div class="col q-ma-md full-height">
    <q-tabs v-model="tabs">
      <q-tab name="config">Configuratie</q-tab>
      <q-tab name="logfile">Serverlog</q-tab>
    </q-tabs>
    <q-tab-panels v-model="tabs" class="full-height">
      <q-tab-panel name="config">
        <q-card class="q-pa-md detail_bg full-width" flat>
          <div class="text-h6">current configuration</div>
          <template v-if="configuration">
            <span class="text-bold">Taxonomy directory:</span> {{ configuration.parser.local_taxonomy_dir }}<br/>
          </template>
          <template v-if="xbrl_cli">
            <span class="text-bold">NT Versie:</span>
            {{ xbrl_cli.nt_version }}
            <span v-if="xbrl_cli.alfa">alfa</span>
            <span v-if="xbrl_cli.beta">beta</span>
            <span v-if="xbrl_cli.taxonomy_package">
              (Als het taxonomy-package een NT versie bevat in de informatie, dan gebruiken we die NT versie)
            </span>
            <br/>
            <span v-if="xbrl_cli.taxonomy_package">
              <span class="text-bold">Taxonomy package:</span> {{ xbrl_cli.taxonomy_package }}<br/>
            </span>
            <div v-if="parse_list" class="q-my-sm">
              <div v-for="ep of parse_list" :key="ep">
                {{ ep }}
              </div>
            </div>
            <span class="text-bold">Parse:</span> {{ xbrl_cli.parse }}<br/>
            <span class="text-bold">Validate:</span> {{ xbrl_cli.validate_nt }}<br/>
            <span class="text-bold">Store:</span> {{ xbrl_cli.store }}<br/>
            <span class="text-bold">Compare:</span> {{ xbrl_cli.compare }}
            <template v-if="xbrl_cli.run_id">
              <span class="text-bold">Run ID:</span>{{ xbrl_cli.run_id }}
            </template>
            <br/>
          </template>
        </q-card>
      </q-tab-panel>
      <q-tab-panel name="logfile">
        <div class="logs q-pa-sm q-ma-sm full-width" id="serverlogs">
          <pre class="loglines"><template v-for="(line, index) of loglines" :key="index">{{ line }}</template></pre>
        </div>
        <q-btn round color="primary" icon="refresh" class=".refresh__button" @click="pos=0"></q-btn>
      </q-tab-panel>
    </q-tab-panels>
  </div>
</template>

<script>
import {api} from 'boot/axios'

export default {
  name: "ParseConfiguration",
  props: {configuration: Object, xbrl_cli: Object, parse_list: Array},
  data() {
    return {
      tabs: "config",
      loglines: [],
      pos: 0
    }
  },
  methods: {
    poll_log: function (timeout) {
      let that = this
      let poller = setTimeout(function () {
          api.get('/admin/get_log', {params: {position: that.pos}})
            .then(response => {
              if (response.data.position > that.pos) {
                that.loglines.push(...response.data.loglines)
                that.pos = response.data.position
                that.$nextTick(function () {
                  let serverlogs = document.getElementById("serverlogs")
                  serverlogs.scrollTop = serverlogs.scrollHeight
                })
              }
              if (that.tabs === 'logfile') {
                that.poll_log(3000)
              }
            })
        }
        , timeout)
      if (this.loglines
        && this.loglines.length > 1
        && this.loglines[this.loglines.length - 1].startsWith("all done")) {
        clearTimeout(poller)
      }
    }
  },
  watch: {
    tabs: function () {
      if (this.tabs === 'logfile') {
        this.poll_log(50)
      }
    },
    "$route.query.pos": function () {
      if (this.$route.query.pos == 0) {
        this.loglines = []
        this.pos = 0
        this.tabs = "logfile"
        this.poll_log(50)
        let query = Object.assign({}, this.$route.query);
        delete query.pos;
        this.$router.push({query});
      }
    },
  }
}
</script>

<style scoped lang="scss">
.logs {
  overflow-y: auto;
  overflow-x: auto;
  background-color: #444444;
  color: #fefefe;
  height: 75vh;
  border-top: 2px solid #000000;
  border-left: 2px solid #000000;
  border-bottom: #eeeeee 2px solid;
  position: relative;
}

/* add a blinking cursor after the loglines */
.loglines::after {
  content: "";
  width: 4px;
  height: 20px;
  bottom: 0;
  background: $yellow;
  display: inline-block;
  animation: cursor-blink 1.5s steps(2) infinite;
}

@keyframes cursor-blink {
  0% {
    opacity: 0;
  }
}


</style>
